Codeforces Beta Round #8 C. Looking for Order 状压

C. Looking for Order

题目连接:

http://www.codeforces.com/contest/8/problem/C

Description

Girl Lena likes it when everything is in order, and looks for order everywhere. Once she was getting ready for the University and noticed that the room was in a mess — all the objects from her handbag were thrown about the room. Of course, she wanted to put them back into her handbag. The problem is that the girl cannot carry more than two objects at a time, and cannot move the handbag. Also, if he has taken an object, she cannot put it anywhere except her handbag — her inherent sense of order does not let her do so.

You are given the coordinates of the handbag and the coordinates of the objects in some Сartesian coordinate system. It is known that the girl covers the distance between any two objects in the time equal to the squared length of the segment between the points of the objects. It is also known that initially the coordinates of the girl and the handbag are the same. You are asked to find such an order of actions, that the girl can put all the objects back into her handbag in a minimum time period.

Input

The first line of the input file contains the handbag’s coordinates xs, ys. The second line contains number n (1 ≤ n ≤ 24) — the amount of objects the girl has. The following n lines contain the objects’ coordinates. All the coordinates do not exceed 100 in absolute value. All the given positions are different. All the numbers are integer.

Output

In the first line output the only number — the minimum time the girl needs to put the objects into her handbag.

In the second line output the possible optimum way for Lena. Each object in the input is described by its index number (from 1 to n), the handbag’s point is described by number 0. The path should start and end in the handbag’s point. If there are several optimal paths, print any of them.

Sample Input

0 0
2
1 1
-1 1

Sample Output

8
0 1 2 0

Hint

题意

平面上有n个物品,这个小朋友会去拿这些物品,然后拿到返回包的位置。

但是这个小朋友一次最多拿两个物品,问你怎么去拿,才能使得把所有物品都拿到包的位置,且走的距离和最小

题解:

比较显然的状压,状压中有一个剪枝,显然拿的顺序是随意的,我先拿和后拿都是一样的。

所以可以直接return就好了。

代码

#include<bits/stdc++.h>
using namespace std;

const int maxn = 24;
int dp[1<<maxn],pre[1<<maxn];
int d[maxn+2][maxn+2],x[maxn+2],y[maxn+2];
int n;
int dfs(int x)
{
    if(dp[x]!=-1)return dp[x];
    dp[x]=1e9;
    for(int i=0;i<n;i++)
    {
        if(x&(1<<i))
        {
            int next = dfs(x^(1<<i));
            if(dp[x]>next+d[n][i]+d[i][n])
            {
                dp[x]=next+d[n][i]+d[i][n];
                pre[x]=x^(1<<i);
            }
            for(int j=i+1;j<n;j++)
            {
                if(x&(1<<j))
                {
                    int next = dfs(x^(1<<i)^(1<<j));
                    if(dp[x]>next+d[n][i]+d[i][j]+d[j][n])
                    {
                        dp[x]=next+d[n][i]+d[i][j]+d[j][n];
                        pre[x]=x^(1<<i)^(1<<j);
                    }
                }
            }
            break;
        }
    }
    return dp[x];
}
void dfs2(int x)
{
    if(x)
    {
        for(int i=0;i<n;i++)
            if((x^pre[x])&(1<<i))
                printf("%d ",i+1);
        printf("0 ");
        dfs2(pre[x]);
    }
}
int main()
{
    scanf("%d%d",&x[0],&y[0]);
    scanf("%d",&n);
    x[n]=x[0],y[n]=y[0];
    for(int i=0;i<n;i++)
        scanf("%d%d",&x[i],&y[i]);
    for(int i=0;i<=n;i++)
        for(int j=0;j<=n;j++)
            d[i][j]=(x[i]-x[j])*(x[i]-x[j])+(y[i]-y[j])*(y[i]-y[j]);
    memset(dp,-1,sizeof(dp));
    dp[0]=0;
    printf("%d\n",dfs((1<<n)-1));
    printf("0 ");
    dfs2((1<<n)-1);
    printf("\n");
}
    原文作者:qscqesze
    原文地址: https://www.cnblogs.com/qscqesze/p/5381331.html
    本文转自网络文章,转载此文章仅为分享知识,如有侵权,请联系博主进行删除。
点赞